﻿Imports System.Net
Imports System.Net.Security
Imports System.Security.Principal
Imports System.Security.Cryptography.X509Certificates
Imports System.IO
Imports System.Text
Imports System.Web.Script.Serialization
Imports System.Linq

Public Class frmMain
#Region "Constants"
    Const JSON_STRING = """{0}"":{1},"
    Const CHUNKSIZE = 50
#End Region
    Private ESE_URL As String

#Region "Network functions"
    'Certificate validation for https requests
    Private Function ValidateCertificate(sender As Object, certificate As X509Certificate, chain As X509Chain, sslPolicyErrors As SslPolicyErrors) As Boolean
        Return True
    End Function

    'Send the xml and return the response
    Private Function RequestAndResponse(ByVal message As String, ByVal method As String, ByVal url As String) As String
        Dim httpRequest As HttpWebRequest
        Dim cc As CredentialCache
        Dim httpResponse As HttpWebResponse

        ServicePointManager.ServerCertificateValidationCallback = AddressOf ValidateCertificate

        'Set NTLM Authentication
        httpRequest = HttpWebRequest.Create(url)
        httpRequest.UseDefaultCredentials = False
        cc = New CredentialCache()
        'cc.Add(New Uri(url), "NTLM", New NetworkCredential(tbDomain.Text & "\" & tbUsername.Text, tbPassword.Text))
        If cbBasic.Checked Then
            cc.Add(New Uri(url), "Basic", New NetworkCredential(tbDomain.Text & "\" & tbUsername.Text, tbPassword.Text))
        Else
            cc.Add(New Uri(url), "NTLM", New NetworkCredential(tbDomain.Text & "\" & tbUsername.Text, tbPassword.Text))
        End If
        httpRequest.Credentials = cc

        'Set method and content type
        httpRequest.ContentType = "application/json"
        httpRequest.Method = method
        httpRequest.Accept = "application/json,text/javascript; charset=utf-8"

        If TabControl1.SelectedTab.Name = tpAction.Name Then
            httpRequest.ContentType = "application/json;odata=verbose"
            httpRequest.Accept = "application/json;charset=utf-8;odata=verbose"

            httpRequest.Headers.Add("DataServiceVersion: 3.0")
        End If

        httpRequest.Headers.Add("ResourceID: 1")
        httpRequest.Headers.Add("ResourceAccesibleOnly: 1")
        httpRequest.Headers.Add("Division: 001")

        'Set the Message
        If message <> "" Then
            Using s As Stream = httpRequest.GetRequestStream
                Using sw As New StreamWriter(s)
                    sw.Write(message)
                End Using
            End Using
        End If

        'Get the response
        httpResponse = httpRequest.GetResponse()

        'Return the response message
        Using sr As New StreamReader(httpResponse.GetResponseStream, Encoding.GetEncoding("utf-8"))
            RequestAndResponse = sr.ReadToEnd()
        End Using

        ServicePointManager.ServerCertificateValidationCallback = Nothing
    End Function
#End Region

#Region "REST functions"
    Private Function RetrieveBinaryStream(sGuid As String) As MemoryStream
        Dim sUrl As String
        Dim sResponse As String
        Dim js As New JavaScriptSerializer
        Dim s As New MemoryStream()
        Dim b() As Byte
        Try
            If sGuid <> "" Then
                sUrl = ESE_URL
                sUrl = sUrl & String.Format("Binary/?$top=1&$filter=MessageID eq guid'{0}'", sGuid)

                tbMessages.Text = "GET: " & sUrl

                While sUrl.Length > 0

                    sResponse = RequestAndResponse("", "GET", sUrl)
                    tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & sResponse

                    Dim jsonObject As Dictionary(Of String, Object) = js.DeserializeObject(sResponse)

                    Dim document = CType(jsonObject("d"), Dictionary(Of String, Object))

                    If document.ContainsKey("__next") Then
                        sUrl = document("__next")
                        If Not sUrl.Contains("$top=") Then
                            sUrl = String.Format("{0}&$top=1", sUrl)
                        End If
                    Else
                        sUrl = ""
                    End If

                    For Each r As Dictionary(Of String, Object) In document("results")
                        b = Convert.FromBase64String(CType(r("Data"), String))
                        s.Write(b, 0, b.Length)
                    Next
                End While
                s.Close()
            End If
        Catch we As WebException
            Dim err As String
            Using reader As New StreamReader(we.Response.GetResponseStream, Encoding.UTF8)
                err = we.Response.ToString() & vbCrLf & vbCrLf & reader.ReadToEnd()
                tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
            End Using
            MsgBox(err)
        Catch ex As Exception
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & ex.Message
            MsgBox(ex.Message)
        End Try

        Return s
    End Function

    Private Function RetrieveBinaryString(sGuid As String) As String
        Return System.Text.ASCIIEncoding.Unicode.GetString(RetrieveBinaryStream(sGuid).ToArray())
    End Function

    Private Sub RetrieveRequest()
        Dim sUrl As String
        Dim sResponse As String
        Dim js As New JavaScriptSerializer

        Try
            sUrl = ESE_URL
            If tbRequestID.Text.Length > 0 Then
                sUrl = sUrl & String.Format("Request/?$top=1&$filter=RequestID eq {0}", tbRequestID.Text)
            ElseIf tbRequestNumber.Text.Length > 0 Then
                sUrl = sUrl & String.Format("Request/?$top=1&$filter=RequestNumber eq {0}", tbRequestNumber.Text)
            Else
                MessageBox.Show("Please provide a request ID or a request number", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

            sUrl = sUrl & " and PrepareDownloadRequestComments eq true and PrepareDownloadWorkflowComments eq true"

            tbMessages.Text = "GET: " & sUrl

            sResponse = RequestAndResponse("", "GET", sUrl)
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & sResponse

            Dim jsonObject As Dictionary(Of String, Object) = js.DeserializeObject(sResponse)
            Dim document = CType(jsonObject("d"), Dictionary(Of String, Object))

            For Each r As Dictionary(Of String, Object) In document("results")
                tbRequestType.Text = CType(r("RequestType"), String)
                tbRequestNumber.Text = CType(r("RequestNumber"), String)
                tbRequestID.Text = CType(r("RequestID"), String)
                tbRequestDescription.Text = CType(r("Description"), String)
                tbRequestComment.Text = RetrieveBinaryString(CType(r("MessageIDRequestComments"), String))
                tbWorkflowComment.Text = RetrieveBinaryString(CType(r("MessageIDWorkflowComments"), String))
            Next
        Catch we As WebException
            Dim err As String
            Using reader As New StreamReader(we.Response.GetResponseStream, Encoding.UTF8)
                err = we.Response.ToString() & vbCrLf & vbCrLf & reader.ReadToEnd()
                tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
            End Using
            MsgBox(err)
        Catch ex As Exception
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & ex.Message
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Overloads Function CreateBinary(s As MemoryStream) As String
        Dim ms As New MemoryStream(s.ToArray())
        Dim json As New StringBuilder
        Dim buffSize As Integer = CHUNKSIZE * 1024
        Dim outByte(buffSize - 1) As Byte
        Dim retval As Long
        Dim packetNum As Long = 0
        Dim messageID As String = ""
        Dim sUrl As String
        Dim sResponse As String

        Try
            sUrl = ESE_URL & "Binary/"

            ms.Position = 0
            retval = ms.Read(outByte, 0, buffSize)
            Do While retval = buffSize
                json.Clear()
                json.Append("{")
                If messageID <> "" Then
                    json.Append(String.Format(JSON_STRING, "MessageID", """" & messageID & """"))
                End If
                json.Append(String.Format(JSON_STRING, "Sequence", packetNum))
                json.Append(String.Format(JSON_STRING, "Encoded", "true"))
                json.Append(String.Format(JSON_STRING, "DataString", """" & Convert.ToBase64String(outByte) & """")) 'DataString
                json.Remove(json.Length - 1, 1)
                json.Append("}")

                sResponse = RequestAndResponse(json.ToString(), "POST", sUrl)

                If messageID = "" Then
                    Dim js As New JavaScriptSerializer

                    Dim jsonObject As Dictionary(Of String, Object) = js.DeserializeObject(sResponse)
                    Dim document = CType(jsonObject("d"), Dictionary(Of String, Object))
                    messageID = CType(document("MessageID"), String)
                End If

                retval = ms.Read(outByte, 0, buffSize)
                packetNum += 1
            Loop

            If retval <> 0 Then
                ReDim Preserve outByte(retval - 1)

                json.Clear()
                json.Append("{")
                If messageID <> "" Then
                    json.Append(String.Format(JSON_STRING, "MessageID", """" & messageID & """"))
                End If
                json.Append(String.Format(JSON_STRING, "Sequence", packetNum))
                json.Append(String.Format(JSON_STRING, "Encoded", "true"))
                json.Append(String.Format(JSON_STRING, "DataString", """" & Convert.ToBase64String(outByte) & """")) 'DataString
                json.Remove(json.Length - 1, 1)
                json.Append("}")

                sResponse = RequestAndResponse(json.ToString(), "POST", sUrl)

                If messageID = "" Then
                    Dim js As New JavaScriptSerializer

                    Dim jsonObject As Dictionary(Of String, Object) = js.DeserializeObject(sResponse)
                    Dim document = CType(jsonObject("d"), Dictionary(Of String, Object))
                    messageID = CType(document("MessageID"), String)
                End If
            End If
        Catch we As WebException
            Dim err As String
            Using reader As New StreamReader(we.Response.GetResponseStream, Encoding.UTF8)
                err = we.Response.ToString() & vbCrLf & vbCrLf & reader.ReadToEnd()
                tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
            End Using
            MsgBox(err)
        Catch ex As Exception
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & ex.Message
            MsgBox(ex.Message)
        End Try

        Return messageID
    End Function

    Private Overloads Function CreateBinary(s As String) As String
        Dim ms As New MemoryStream(Encoding.Unicode.GetBytes(s))

        Return CreateBinary(ms)
    End Function

    Private Sub CreateRequest()
        Dim json As New StringBuilder
        Dim sUrl As String
        Dim sResponse As String
        Dim messageID As String
        Dim js As New JavaScriptSerializer

        Try
            sUrl = ESE_URL & "Request/"

            json.Append("{")
            json.Append(String.Format(JSON_STRING, "RequestType", tbRequestType.Text))
            json.Append(String.Format(JSON_STRING, "Description", """" & tbRequestDescription.Text & """"))
            If tbRequestComment.Text <> "" Then
                messageID = CreateBinary(tbRequestComment.Text)
                json.Append(String.Format(JSON_STRING, "MessageIDRequestComments", """" & messageID & """"))
            End If
            If tbWorkflowComment.Text <> "" Then
                messageID = CreateBinary(tbWorkflowComment.Text)
                json.Append(String.Format(JSON_STRING, "MessageIDWorkflowComments", """" & messageID & """"))
            End If
            json.Remove(json.Length - 1, 1)
            json.Append("}")

            sResponse = RequestAndResponse(json.ToString(), "POST", sUrl)

            Dim jsonObject As Dictionary(Of String, Object) = js.DeserializeObject(sResponse)
            Dim document = CType(jsonObject("d"), Dictionary(Of String, Object))
            tbRequestID.Text = CType(document("RequestID"), String)
            tbRequestNumber.Text = CType(document("RequestNumber"), String)

        Catch we As WebException
            Dim err As String
            Using reader As New StreamReader(we.Response.GetResponseStream, Encoding.UTF8)
                err = we.Response.ToString() & vbCrLf & vbCrLf & reader.ReadToEnd()
                tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
            End Using
            MsgBox(err)
        Catch ex As Exception
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & ex.Message
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub SendAction()
        Dim sUrl As String
        Dim sResponse As String
        Dim js As New JavaScriptSerializer

        Try
            sUrl = ESE_URL & tbAction.Text

            sResponse = RequestAndResponse(tbInputJSON.Text, "POST", sUrl)

            tbJSONResult.Text = sResponse
        Catch we As WebException
            Dim err As String
            If Not we.Response Is Nothing Then
                Using reader As New StreamReader(we.Response.GetResponseStream, Encoding.UTF8)
                    err = we.Response.ToString() & vbCrLf & vbCrLf & reader.ReadToEnd()
                    tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
                End Using
            Else
                err = we.Message
                tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & err
            End If
            MsgBox(err)
        Catch ex As Exception
            tbMessages.Text = tbMessages.Text & vbCrLf & vbCrLf & ex.Message
            MsgBox(ex.Message)
        End Try
    End Sub



#End Region

#Region "UI Events"
    Private Sub btnRetrieve_Click(sender As Object, e As EventArgs) Handles btnRetrieve.Click
        ESE_URL = tbURL.Text & "Exact.Entity.REST.svc/"
        RetrieveRequest()
    End Sub

    Private Sub btnCreate_Click(sender As Object, e As EventArgs) Handles btnCreate.Click
        ESE_URL = tbURL.Text & "Exact.Entity.REST.svc/"
        CreateRequest()
    End Sub

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        tbUsername.Text = My.Settings.Username
        tbDomain.Text = My.Settings.Domain
        tbURL.Text = My.Settings.URL

        tbAction.Text = My.Settings.Action
        tbInputJSON.Text = My.Settings.JSON
    End Sub

    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        My.Settings.Username = tbUsername.Text
        My.Settings.Domain = tbDomain.Text
        My.Settings.URL = tbURL.Text

        My.Settings.Action = tbAction.Text
        My.Settings.JSON = tbInputJSON.Text
    End Sub
#End Region

    Private Sub btnAction_Click(sender As Object, e As EventArgs) Handles btnAction.Click
        ESE_URL = tbURL.Text & "Exact.action.REST.svc/"
        SendAction()
    End Sub

End Class
